local medic_dozer = {
	Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_medic_classic/ene_bulldozer_medic_classic"),
	Idstring("units/pd2_dlc_drm/characters/ene_bulldozer_medic/ene_bulldozer_medic"),
	Idstring("units/pd2_dlc_bph/characters/ene_murkywater_bulldozer_medic/ene_murkywater_bulldozer_medic"),
	Idstring("units/pd2_dlc_bex/characters/ene_swat_dozer_medic_policia_federale/ene_swat_dozer_medic_policia_federale")
}
local backup_unit_categories = {}

local OldFunc = GroupAIStateBesiege._perform_group_spawning
function GroupAIStateBesiege:_perform_group_spawning(spawn_task, ...)
	local unit_categories = tweak_data.group_ai.unit_categories
	local units_remaining_keys = table.map_keys(spawn_task.units_remaining)
	if table.find_value(units_remaining_keys, function(v)
		return unit_categories[v].special_type == "tank"
	end) then
		if self:_get_special_unit_type_count("medic") >= managers.job:current_spawn_limit("medic") then
			for u_type_name, spawn_info in pairs(spawn_task.units_remaining) do
				if unit_categories[u_type_name].special_type == "tank" then
					if not backup_unit_categories[u_type_name] then
						backup_unit_categories[u_type_name] = {
							orig = unit_categories[u_type_name].unit_types,
							exclude = deep_clone(unit_categories[u_type_name].unit_types)
						}
						for _, units in pairs(backup_unit_categories[u_type_name].exclude) do
							table.remove_condition(units, function(v)
								return table.contains(medic_dozer, v)
							end)
							if #units == 0 then
								backup_unit_categories[u_type_name].exclude = nil
								break
							end
						end
					end
					if backup_unit_categories[u_type_name].exclude then
						unit_categories[u_type_name].unit_types = backup_unit_categories[u_type_name].exclude
					else
						spawn_info.amount = 0
					end
				end
			end
			OldFunc(self, spawn_task, ...)
			for u_type_name, spawn_info in pairs(spawn_task.units_remaining) do
				if backup_unit_categories[u_type_name] then
					unit_categories[u_type_name].unit_types = backup_unit_categories[u_type_name].orig
				end
			end
		else
			return OldFunc(self, spawn_task, ...)
		end
	elseif table.find_value(units_remaining_keys, function(v)
		if unit_categories[v].is_captain then
			return true
		end
		for _, units in pairs(unit_categories[v].unit_types) do
			if #units ~= 1 then
				return false
			end
			if units[1] ~= Idstring("units/pd2_dlc_vip/characters/ene_phalanx_1/ene_phalanx_1") then
				return false
			end
		end
		return not unit_categories[v].special_type
	end) then
		local OldExtraFunc = safe_spawn_unit
		function safe_spawn_unit(...)
			local unit = OldExtraFunc(...)
			self:unregister_special_unit(unit:key(), "shield")
			return unit
		end
		OldFunc(self, spawn_task, ...)
		safe_spawn_unit = OldExtraFunc
	else
		return OldFunc(self, spawn_task, ...)
	end
end
